#/*
# * +--------------------------------------------------------------------------+
# * | Copyright 2002 Rational Software Corporation.  All Rights Reserved.      |
# * | This software contains proprietary and confidential information of       |
# * | Rational and its suppliers.  Use, disclosure or reproduction is          |
# * | prohibited without the prior express written consent of Rational.        |
# * +--------------------------------------------------------------------------+
# */
########################################################################
#testPjCLib.pl
#
# This file contains examples on how to use the PjCLib.pm module.  
# It also serves as a simple test driver for the module.
#
########################################################################

use PjCLib;
use Win32::OLE;
require CQPerlExt;


################
# main
################

$session = logon();

myMain();
exit;

sub myMain {

    print "PjCLib.pm Module Test Driver: This driver will perform some simple tests\n";
    print "of the PjCLib by calling its externally visible subroutines.\n\n\n";
    PjCLib->initializePjCLibrary($session, PjCLib->BOOLEAN_TRUE);

    #
    # To translate a PjC table name, pass the Table's PjC Display Name into PjCLib->getCQTableDbName.
    # It will return the ClearQuest physical database table name (also known as the entity def db_name).
    #
    print "Test #1 - getCQTableDbName(): Translate table names (take a sample):\n";
    print "   Translate ... fulltag_dim = ". PjCLib->getCQTableDbName("fulltag_dim") . "\n";
    print "   Translate ... document_dim = ". PjCLib->getCQTableDbName("document_dim"). "\n";
    print "   Translate ... project_dim = ". PjCLib->getCQTableDbName("project_dim"). "\n";
    print "   Translate ... level_dim = ". PjCLib->getCQTableDbName("level_dim"). "\n";
    print "   Translate ... clearcase_measure = ". PjCLib->getCQTableDbName("clearcase_measure"). "\n";
    print "   Translate ... MSPAggregate_measure = ". PjCLib->getCQTableDbName("MSPAggregate_measure"). "\n";
    print "   Translate ... Design_Measure = ". PjCLib->getCQTableDbName("Design_Measure"). "\n";
    print "   Translate ... ActualStart = ". PjCLib->getCQTableDbName("ActualStart"). "\n";

    #
    # To translate a PjC field name, pass the Table's PjC Display Name and the Field's PjC Display Name
    # into PjCLib->getCQFieldDbName. It will return the ClearQuest physical field name name (also known as
    # the field def db_name).
    #
    print "\nTest #2 - getCQFieldDbName(): Translate field names (take a sample):\n";

    print "   Translate ... MSP_Task_Measure.MSPBaselineWork = ". PjCLib->getCQFieldDbName("MSP_Task_Measure", "MSPBaselineWork") . "\n";
    print "   Translate ... requirement_measure.hasChildren_fk = ". PjCLib->getCQFieldDbName("requirement_measure", "hasChildren_fk") . "\n";
    print "   Translate ... Design_Measure.Num_Design_Items = ". PjCLib->getCQFieldDbName("Design_Measure", "Num_Design_Items") . "\n";
    print "   Translate ... Design_Measure.collection_fk = ". PjCLib->getCQFieldDbName("Design_Measure", "collectiondate_fk") . "\n";
    print "   Translate ... BaselineFinish.BaselineFinish_name = ". PjCLib->getCQFieldDbName("BaselineFinish", "BaselineFinish_name") . "\n";

    print "\nTest #3 - Dump the values in table 'project_dim':\n";
     my $queryDefObj = $session->BuildQuery("project_dim");
    $queryDefObj->BuildField("project");
    $resultSetObj = $session->BuildResultSet($queryDefObj);
    $resultSetObj->Execute();

    while ($resultSetObj->MoveNext() == $CQPerlExt::CQ_SUCCESS) {
       $result = $resultSetObj->GetColumnValue(1);
        print "    result = $result\n";
    }


    print "\nTest #4 - Get the dbid of value 'Tutorial':\n";
    #setDimTableValue("project_dim", "project", "Project Test");
    $dbid = getPhysicalReferenceDBID("project_dim", "project", "\'Tutorial\'");
    print ("dbid = $dbid");

    dumpTable();

}



sub logon {

    #
    # Use the internal DashboardSystem login to get access to the Dashboard database
    #
    my $session = Win32::OLE->new('CLEARQUEST.SESSION');
    my $session = CQPerlExt::CQSession_Build();  
    $session->UserLogon("dashboardsystem", "dashboardsystem", "tstd1", "Dashboard");
    return $session;
}

sub dumpTable {
    my $queryDefObj = $session->BuildQuery("project_dim");
    $queryDefObj->BuildField("project");
    $resultSetObj = $session->BuildResultSet($queryDefObj);
    $resultSetObj->Execute();

    while ($resultSetObj->MoveNext() == $CQPerlExt::CQ_SUCCESS) {
       $result = $resultSetObj->GetColumnValue(1);
        print "    result = $result\n";
    }

}

sub setDimTableValue {
    my ($dimTableName, 
        $dimTableFieldName,
        $dimTableFieldValue
        ) = @_;

    $entity = $session->BuildEntity($dimTableName);
    $failure = $entity->SetFieldValue($dimTableFieldName, $dimTableFieldValue);
    $retVal = $entity->Validate();
    printf("entity->Validate() return value = $retVal\n");
    $entity->Commit();
    printf("entity->Commit() return value = $retVal\n");
    
}



